;           
;     ,       ....
;==========================================================================
;
;       Register Definitions
;
;==========================================================================

;W                            EQU     H'0000'
;F                            EQU     H'0001'

;----- Register Files------------------------------------------------------

;INDF                         EQU     H'0000'
;TMR0                         EQU     H'0001'
;PCL                          EQU     H'0002'
;STATUS                       EQU     H'0003'
;FSR                          EQU     H'0004'
;PORTA                        EQU     H'0005'
;PORTB                        EQU     H'0006'
;EEDATA                       EQU     H'0008'
;EEADR                        EQU     H'0009'
;PCLATH                       EQU     H'000A'
;INTCON                       EQU     H'000B'

;OPTION_REG                   EQU     H'0081'
;TRISA                        EQU     H'0085'
;TRISB                        EQU     H'0086'
;EECON1                       EQU     H'0088'
;EECON2                       EQU     H'0089'

;----- STATUS Bits --------------------------------------------------------

;IRP                          EQU     H'0007'
;RP1                          EQU     H'0006'
;RP0                          EQU     H'0005'
;NOT_TO                       EQU     H'0004'
;NOT_PD                       EQU     H'0003'
;Z                            EQU     H'0002'
;DC                           EQU     H'0001'
;C                            EQU     H'0000'

;----- INTCON Bits --------------------------------------------------------

;GIE                          EQU     H'0007'
;EEIE                         EQU     H'0006'
;T0IE                         EQU     H'0005'
;INTE                         EQU     H'0004'
;RBIE                         EQU     H'0003'
;T0IF                         EQU     H'0002'
;INTF                         EQU     H'0001'
;RBIF                         EQU     H'0000'

;0-      B4-B7  0   //// 1   
;1-     RB0 /int 
;2-    
;3-    PORTB 
;4-   int  PORTB 0
;5-    
;6-   FLACH 
;7-    

;----- OPTION_REG Bits ----------------------------------------------------

;NOT_RBPU                     EQU     H'0007'
;INTEDG                       EQU     H'0006'
;T0CS                         EQU     H'0005'
;T0SE                         EQU     H'0004'
;PSA                          EQU     H'0003'
;PS2                          EQU     H'0002'
;PS1                          EQU     H'0001'
;PS0                          EQU     H'0000'

;----- EECON1 Bits --------------------------------------------------------

;EEIF                         EQU     H'0004'
;WRERR                        EQU     H'0003'
;WREN                         EQU     H'0002'
;WR                           EQU     H'0001'
;RD                           EQU     H'0000'

	#include p16f84a.inc
	processor 16f84a
	;   
const_delitel 		equ .5;        
const_clous1  		equ .22 ;      
const_delta_clous1	equ .7;       
const_open1		equ .25 ;      
const_delta_stop1	equ .2;    ___|`````|___     	
	


const_clous2  		equ .22 ;      
const_delta_clous2	equ .7;       
const_open2		equ .25 ;      
const_delta_stop2	equ .2;    ___|`````|___     	


	
	cblock 0x0f
	Temp_PORTB ;    B     
	temp
	counter
	counter2
	jmp
	del_counter
	delitel
	delay_reg
	delay_reg_1
	
	del1
	del2
	del3
	del4
	del5
	del6
	del7
	del8
	del9
	del10
	del11
	del12
	del13
	del14

;      



	endc

#define  clous1_1 	PORTA , 2
#define  clous1_2	PORTA , 3
#define  open1		PORTA , 1
#define  stop1		PORTA , 0

#define  clous2_1	PORTB , 2
#define  clous2_2	PORTB , 3
#define  open2	 	PORTB , 1
#define  stop2		PORTB , 0




;  
	
	org 0x2007
	de 0xfa;   
	org 0x000 ;   
	goto begin;   

	org 0x004;   
;           
;    
	btfsc INTCON , 0 
	goto  int_input;  
	btfsc INTCON , 2
	goto  int_TMR;    
	; -        INTCON
	movlw b'10101000';    INTCON
;           ||||||||
;           |||||||'--0-      B4-B7  0   //// 1   
;           ||||||'---1-     RB0 /int 
;           |||||'----2-    
;           ||||'-----3-    PORTB 
;           |||'------4-   int  PORTB 0
;           ||'-------5-    
;           |'--------6-   FLACH 
;           '---------7-    
	movwf INTCON;W>>>INTCON 
	retfie
;     

tabl 
	movfw jmp
	addwf PCL , f
	goto tmr1
	goto tmr2
	goto tmr3
	goto tmr4
	goto tmr5
	goto tmr6
	goto tmr7
	goto tmr8
	goto tmr9
	goto tmr10
	goto tmr11
	goto tmr12
	goto tmr13
	goto tmr14

;========================================================================
;
;========================================================================
tmr1
	bcf open1
	movlw const_delta_stop1
	movwf del2
	bsf stop1
;++++++++++++
	rlf counter , f
	bcf counter , 0
;++++++++++++
	goto end_int_TMR0
tmr2
	bcf stop1
	goto end_int_TMR0
;*************************************************************************
tmr3;  3
	bcf clous1_1	
	bcf clous1_2
	movlw const_delta_stop1
	movwf del5
	bsf stop1
;++++++++++++++
clrf counter
bsf counter , 0;   
;++++++++++++++
	goto end_int_TMR0
tmr4
	bsf clous1_2	
	goto end_int_TMR0

tmr5
	bcf stop1
	goto end_int_TMR0

;======================================================================
tmr6	bcf open2
	movlw const_delta_stop2
	movwf del7
	bsf stop2
;++++++++++++
	rlf counter2 , f
	bcf counter2 , 0
;++++++++++++
	goto end_int_TMR0

tmr7	bcf stop2	
	goto end_int_TMR0


tmr8	bcf clous2_1	
	bcf clous2_2
	movlw const_delta_stop2
	movwf del10
	bsf stop2
;++++++++++++++
	clrf counter2
	bsf counter2 , 0;   
;++++++++++++++	
	goto end_int_TMR0

tmr9	bsf clous2_2
	goto end_int_TMR0


tmr10	bcf stop2
	
	
	goto end_int_TMR0
tmr11
	
	
	goto end_int_TMR0
tmr12
	
	
	
	
	
	goto end_int_TMR0
tmr13

	
	
	
	goto end_int_TMR0
tmr14

	
	
	
	goto end_int_TMR0

;========================================================================
;        
;======================================================================== 
cold_start
	bsf STATUS, RP0 ;   1 
	movlw b'00000000';    
	movwf TRISA^80h
	movlw b'11110000';    B
	movwf TRISB^80h
	movlw b'01010111';            OPTION ( ,     .)
;           ||||||||
;           |||||||'-/
;           ||||||'--/
;           |||||'---/
;           ||||'----  0  TMR0 /// 1
;           |||'-----     1-   0-   
;           ||'------   TOCKI 0-    1-    TOCKI
;           |'-------   INT 0-   1-   
;           '--------   PORTB 0-  1-
	movwf OPTION_REG^80h;     W>>>OPTIN
	bcf STATUS,RP0;  0 
	movlw b'00101000';    INTCON
;           ||||||||
;           |||||||'--0-      B4-B7  0   //// 1   
;           ||||||'---1-     RB0 /int 
;           |||||'----2-    
;           ||||'-----3-    PORTB 
;           |||'------4-   int  PORTB 0
;           ||'-------5-    
;           |'--------6-   FLACH 
;           '---------7-    
	movwf INTCON;W>>>INTCON
	clrf STATUS;  STATUS
	return;  
	
hot_start
	movlw const_delitel
	movwf delitel
	clrf counter
	clrf counter2
	bsf counter2 , 0; 
	bsf counter , 0;   
	call clr1
	call clr2
	
	clrf del11
	clrf del12
	clrf del13
	clrf del14

	
	clrf PORTB
	clrf PORTA

	call delay;                
	movfw PORTB;             (  )
	bcf INTCON , T0IF ;     
	bsf INTCON , GIE ;    
	return;

clr1  ;   
	clrf del1
	clrf del2
	clrf del3
	clrf del4
	clrf del5
	return
clr2  ;   
	clrf del6
	clrf del7
	clrf del8
	clrf del9
	clrf del10
	return

;=======================================================================================
;   0,2  
;=======================================================================================
delay
	movlw .50;  
	movwf delay_reg
	;clrf delay_reg
	clrf delay_reg_1
delay_label_1	
	decfsz delay_reg_1 , f
	goto delay_label_1	
	decfsz delay_reg , f
	goto delay_label_1
	return
	

;=======================================================================================
;=======================================================================================
;    
;=======================================================================================
end_int_input
	movfw PORTB
	movwf Temp_PORTB
	bcf INTCON , 0
	retfie

end_int_TMR0
	bcf INTCON , T0IF ;     
	retfie



;                  =======================================================


;=======================================================================================
;   
;=======================================================================================
int_input	;     (    ,       ..)
;   Temp_PORTB      
;     
;   0,1  
	movfw PORTB
	movwf temp
	movfw  Temp_PORTB
	xorwf temp , w
	comf temp,f
	andwf temp ,f
;       |___    = 1
;   (  )
	call delay
	movfw PORTB
	movwf  Temp_PORTB
	comf Temp_PORTB , w		
	andwf temp ,f
	
	movfw PORTB
	movwf Temp_PORTB

	btfsc temp , 7;      
	goto cn_1
	btfsc temp , 6;  1    
	goto stop_1	
	btfsc temp , 5;       
	goto cn_2
	btfsc temp , 4;  2    
	goto stop_2
	goto end_int_input
	

cn_1	
	btfss PORTB , 6 
	goto end_int_input;    
	;    1
	btfsc counter , 0
	goto operation_open
	btfsc counter , 1
	goto operation_stop_1
	btfsc counter , 2
	goto operation_clous
	btfsc counter , 3
	goto operation_stop_2	
	;    
	clrf counter 
	bsf counter , 0;   
	goto end_int_input
	
operation_open;        
	call clr1
	bcf stop1
	bcf clous1_1
	bcf clous1_2
	bsf open1
	movlw const_open1
	movwf del1		
	rlf counter , f
	bcf counter , 0
	goto end_int_input
operation_stop_1
	call clr1
	bcf clous1_1
	bcf clous1_2
	bcf open1
	movlw const_delta_stop1
	movwf del2
	bsf stop1
	rlf counter , f
	bcf counter , 0
	goto end_int_input
operation_stop_2
	call clr1
	bcf clous1_1
	bcf clous1_2
	bcf open1
	bsf stop1
	movlw const_delta_stop1
	movwf del5
	clrf counter
	bsf counter , 0;   
	goto end_int_input
operation_clous
	call clr1
	bcf open1
	bcf stop1		
	bsf clous1_1
	movlw const_clous1;     
	movwf del3
	movlw const_delta_clous1;      
	movwf del4
	rlf counter , f
	bcf counter , 0
	goto end_int_input
;========================================================================================
;      
;========================================================================================
stop_1	call clr1
	bcf clous1_1
	bcf clous1_2
	bcf open1
	bsf stop1
	movlw const_delta_stop1
	movwf del5
	clrf counter
	bsf counter , 0;   
	goto end_int_input

;========================================================================================
;   
;========================================================================================
cn_2
	btfss PORTB , 4 
	goto end_int_input;    
	;    2
	btfsc counter2 , 0
	goto operation_open2
	btfsc counter2 , 1
	goto operation_stop2_1
	btfsc counter2 , 2
	goto operation_clous2
	btfsc counter2 , 3
	goto operation_stop2_2	
	;    
	clrf counter2 
	bsf counter2 , 0;   
	goto end_int_input

operation_open2;        
	call clr2
	bcf stop2
	bcf clous2_1
	bcf clous2_2
	bsf open2
	movlw const_open2
	movwf del6		
	rlf counter2 , f
	bcf counter2 , 0
	goto end_int_input
operation_stop2_1
	call clr2
	bcf clous2_1
	bcf clous2_2
	bcf open2
	movlw const_delta_stop2
	movwf del7
	bsf stop2
	rlf counter2 , f
	bcf counter2 , 0
	goto end_int_input
operation_stop2_2
	call clr2
	bcf clous2_1
	bcf clous2_2
	bcf open2
	bsf stop2
	movlw const_delta_stop2
	movwf del10
	clrf counter2
	bsf counter2 , 0;   
	goto end_int_input
operation_clous2
	call clr2
	bcf open2
	bcf stop2		
	bsf clous2_1
	movlw const_clous2;     
	movwf del8
	movlw const_delta_clous2;      
	movwf del9
	rlf counter2 , f
	bcf counter2 , 0
	goto end_int_input
;==================================================================================
;    
;==================================================================================
stop_2	call clr2
	bcf clous2_1
	bcf clous2_2
	bcf open2
	bsf stop2
	movlw const_delta_stop2
	movwf del10
	clrf counter2
	bsf counter2 , 0;   
	goto end_int_input
;===================================================================================


int_TMR
	;   
	decfsz delitel , f
	goto end_int_TMR0
	movlw const_delitel
	movwf delitel
;   
;       goto     
	movlw del1
	movwf FSR
	movlw .0
	movwf jmp
;	clrf jmp
	movlw .11;  
	movwf del_counter
	
next clrw 
	iorwf INDF , w
	btfsc STATUS , Z 
	goto  L_inc_1  
	decfsz INDF , f
	goto  L_inc_1
	;  0 	
	goto  tabl
	
L_inc_1	incf FSR , f
	incf jmp , f
		
	decfsz del_counter , f
	goto next
	
	goto end_int_TMR0






begin
	call cold_start
	call hot_start
	nop
	call delay
	goto $
	
;	btfss portb , 7
;	goto 
;	decfsz keyboard_scan_1 , f
;	goto 
	
	
;	goto 
	
	
	
	end
